=== debian/changelog ===
taglib (2.0.2-2) unstable; urgency=medium

  * debian/control: Let libtag-c-dev and libtag-dev depends on each
    other for now to workaround the fact that library development cmake
    files cannot be split into the 2 development packages.

 -- Boyuan Yang <byang@debian.org>  Sat, 11 Jan 2025 10:39:53 -0500

taglib (2.0.2-1) unstable; urgency=medium

  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Fri, 10 Jan 2025 17:41:38 -0500

taglib (2.0.2-1~exp3) experimental; urgency=medium

  * debian/control: Add back libtagc0-dev and libtag1-dev as
    transitional dummy packages to ease library transition.

 -- Boyuan Yang <byang@debian.org>  Thu, 09 Jan 2025 21:26:24 -0500

taglib (2.0.2-1~exp2) experimental; urgency=medium

  * debian/control: Use new taglib homepage.
  * debian/control: Use Rules-Requires-Root: no.

 -- Boyuan Yang <byang@debian.org>  Fri, 29 Nov 2024 08:09:04 -0500

taglib (2.0.2-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Boyuan Yang <byang@debian.org>  Sat, 28 Sep 2024 11:04:04 -0400

taglib (2.0.1-1~exp6) experimental; urgency=medium

  * debian/libtag2.symbols: Refresh symbols again.

 -- Boyuan Yang <byang@debian.org>  Sat, 08 Jun 2024 18:41:35 -0400

taglib (2.0.1-1~exp5) experimental; urgency=medium

  * debian/libtag2.symbols: Refresh symbols again.

 -- Boyuan Yang <byang@debian.org>  Thu, 16 May 2024 18:37:39 -0400

taglib (2.0.1-1~exp4) experimental; urgency=medium

  * debian/libtag2.symbols: Refresh symbols again.

 -- Boyuan Yang <byang@debian.org>  Thu, 16 May 2024 17:03:24 -0400

taglib (2.0.1-1~exp3) experimental; urgency=medium

  * debian/libtag2.symbols: Refresh symbols again.
  * debian/control: Move package description to the source package section.

 -- Boyuan Yang <byang@debian.org>  Thu, 16 May 2024 11:55:49 -0400

taglib (2.0.1-1~exp2) experimental; urgency=medium

  * Refresh symbols using buildd logs.

 -- Boyuan Yang <byang@debian.org>  Mon, 06 May 2024 08:32:45 -0400

taglib (2.0.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/libtag2.symbols: Add amd64 symbols.
  * debian/control: Replace pkg-config => pkgconf.

 -- Boyuan Yang <byang@debian.org>  Sat, 04 May 2024 18:28:25 -0400

taglib (2.0-1~exp3) experimental; urgency=medium

  * Refresh symbols again.
  * debian/control: Let new dev packages also declare versioned Breaks+Replaces
    on old dev packages. (Closes: #1061939)

 -- Boyuan Yang <byang@debian.org>  Tue, 30 Jan 2024 09:03:39 -0500

taglib (2.0-1~exp2) experimental; urgency=medium

  * debian/*.symbols: Refresh symbols with pkgkde_symbolshelper using
    buildd logs.

 -- Boyuan Yang <byang@debian.org>  Mon, 29 Jan 2024 23:29:24 -0500

taglib (2.0-1~exp1) experimental; urgency=medium

  * New upstream release.
    + API/ABI incompatible with previous versions. Deprecated functions
      removed. Non-deprecated functions are kept API compatible.
  * Major rework on packaging following ABI/API break:
    + Rename C++ dev package libtag1-dev => libtag-dev.
    + Let the new libtag-dev provides libtag1-dev.
    + Drop flavour-based library packaging and only use libtag2 for
      C++ library package name. (see changelog history on flavors)
    - Drop transitional package libtag1v5.
    - Drop old real library package libtag1v5-vanilla.
    + C library SONAME bump: libtagc0 => libtag-c2.
    + Properly rename C library dev package: libtagc0-dev => libtag-c-dev.
    + Let libtag-c-dev provides libtagc0-dev.
  * debian/rules:
    + Explicitly use -DVISIBILITY_HIDDEN=ON from CMake.
    + No longer install README.bindings, now useless.
    + Do not set LIB_INSTALL_DIR, now useless.

 -- Boyuan Yang <byang@debian.org>  Sat, 27 Jan 2024 21:04:40 -0500
