=== debian/changelog ===
taglib (2.1.1-2) unstable; urgency=medium

  * Team upload.
  * Drop patch that is overridden by a .in template. (Closes: #1111132)
  * Drop transitional package libtagc0-dev.

 -- Bastian Germann <bage@debian.org>  Fri, 19 Sep 2025 21:42:48 +0200

taglib (2.1.1-1) unstable; urgency=medium

  * Upload to unstable.
  * debian/libtag2.symbols: Update symbols from buildd buildlog.
  * debian/libtag-c2.symbols: Add Build-Depends-Package field.
  * debian/copyright: Avoid old fsf mailing address.

 -- Boyuan Yang <byang@debian.org>  Sun, 31 Aug 2025 12:56:52 -0400

taglib (2.1.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * debian/copyright: Minor update.
  * debian/libtag-dev.install: Install newly-added headers.
    The taglib_config.h is used in both C and CPP bindings, but we
    installed it into libtag-dev for now.

 -- Boyuan Yang <byang@debian.org>  Mon, 11 Aug 2025 22:55:48 -0400
