=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
 Build-Depends-Indep:
  doxygen <!nodoc>,
  graphviz <!nodoc>,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://taglib.org/
 Vcs-Git: https://salsa.debian.org/multimedia-team/taglib.git
@@ -42,7 +42,6 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- dpkg-dev,
  libtag-c-dev (= ${binary:Version}),
  libtag2 (= ${binary:Version}),
  zlib1g-dev,
@@ -131,12 +130,3 @@
  .
  This is the runtime package for programs that use the TagLib Audio Meta-Data
  Library.
-
-Package: libtagc0-dev
-Section: oldlibs
-Architecture: any
-Depends:
- libtag-c-dev (= ${binary:Version}),
- ${misc:Depends},
-Description: transitional dummy package
- This is a transitional dummy package. It can safely be removed.
