=== debian/watch ===
version=4
opts="dversionmangle=s/\+dfsg\.\d*$//, \
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%taglib-$1.tar.gz%" \
https://github.com/taglib/taglib/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
